/*
								+---------------------------------+
								|                                 |
								|   ***   OpenGL Example 1   ***  |
								|                                 |
								|  Copyright   -tHE SWINe- 2005  |
								|                                 |
								|            Main.cpp             |
								|                                 |
								+---------------------------------+
*/

#include <crtdbg.h>
#include <windows.h>
#include <malloc.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
#include <gl/gl.h>
#include <gl/glu.h>

#include "OpenGlDrv.h"

LRESULT CALLBACK Wokno(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam);

// === Engine ===
#define APPNAME "OpenGL example 1"
#define WNDNAME "OpenGL example 1"
static int n_Width =  512;
static int n_Height = 384; // rozlien
static int b_focus = true;

void Render()
{
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glShadeModel(GL_SMOOTH);

	glBegin(GL_TRIANGLES);

	glColor3f(1, 0, 0);
	glVertex2f(-.5f, -.5f);

	glColor3f(0, 1, 0);
	glVertex2f(   0,  .5f);

	glColor3f(0, 0, 1);
	glVertex2f( .5f, -.5f);

	glEnd();

	Blit();
}

// main
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdline, int nCmdShow)
{
	char szAppName[] = APPNAME;
	WNDCLASSEX wndclass;
	int b_full_scr;
	HWND hwnd;
	MSG msg;

	b_full_scr = MessageBox(0, "Fullscreen ?", "GL window", MB_YESNO) == IDYES;

	wndclass.cbSize			= sizeof(wndclass);
	wndclass.style			= CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc	= Wokno;
	wndclass.cbClsExtra		= 0;
	wndclass.cbWndExtra		= 0;
	wndclass.hInstance		= hInstance;
	wndclass.hIcon			= LoadIcon(hInstance, IDI_APPLICATION);
	wndclass.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wndclass.lpszMenuName	= 0;
	wndclass.lpszClassName	= szAppName;
	wndclass.hIconSm		= LoadIcon(NULL, IDI_APPLICATION);
	RegisterClassEx(&wndclass);
	if(b_full_scr) {
		hwnd = CreateWindowEx(WS_EX_TOPMOST, szAppName,
			WNDNAME, WS_POPUP,
			0,//(GetSystemMetrics(SM_CXSCREEN) - n_Width) / 2,
			0,//(GetSystemMetrics(SM_CYSCREEN) - n_Height) / 2,
			n_Width, n_Height, NULL,
			NULL, hInstance, NULL);
	} else {
		hwnd = CreateWindow(szAppName,
			WNDNAME, WS_DLGFRAME | WS_CLIPCHILDREN | WS_CLIPSIBLINGS,
			(GetSystemMetrics(SM_CXSCREEN) - n_Width) / 2,
			(GetSystemMetrics(SM_CYSCREEN) - n_Height) / 2,
			n_Width, n_Height, NULL,
			NULL, hInstance, NULL);
	}
	ShowWindow(hwnd, nCmdShow);
	UpdateWindow(hwnd);
	ShowCursor(FALSE);
	// vytvo okno


	if(!Init_GL(hwnd, n_Width, n_Height, 32, b_full_scr))
		return 0;
	// GL

	while(1) {
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) { 
			if(msg.message == WM_QUIT)
				break;
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        } else if(b_focus)
			Render();
	}
	// kresl ...

	Terminate_GL();

	return msg.wParam;
}

LRESULT CALLBACK Wokno(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	switch(iMsg) {
	case WM_KEYDOWN:
		if(wParam == VK_ESCAPE) {
			ShowCursor(TRUE);
			SendMessage(hwnd, WM_CLOSE, 0, 0);
			break;
		}
		return 0;

	case WM_SETFOCUS:
		b_focus = 1;
		return 0;

	case WM_KILLFOCUS:
		b_focus = 0;
		return 0;

	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}

	return DefWindowProc(hwnd, iMsg, wParam, lParam);
}
